package com.agiledeveloper;

import java.lang.invoke.MethodHandle;
import java.lang.invoke.MethodHandles;
import java.lang.invoke.MethodType;

public class Sample {
  public double instanceMethod(double value) {
    System.out.println("instanceMethod");
    return value * 2;
  }

  public static void staticMethod() {
    System.out.println("staticMethod");
  }

  public static void main(String[] args) throws Throwable {
    Sample.staticMethod();

    Sample sample = new Sample();
    sample.instanceMethod(2);

    System.out.println("--------------");

    MethodHandles.Lookup lookup = MethodHandles.lookup();
    MethodHandle staticMethodHandle =
        lookup.findStatic(Sample.class, "staticMethod", MethodType.methodType(void.class));

    staticMethodHandle.invokeExact();

    MethodHandle instanceMethodHandle = lookup.findVirtual(
        Sample.class, "instanceMethod", MethodType.methodType(
        double.class, double.class));

    MethodHandle instanceMethodHandleOnSample = instanceMethodHandle.bindTo(sample);

    double result = (double) instanceMethodHandleOnSample.invokeExact(4.0);
    System.out.println(result);
  }
}













